/* loop.c (emx+gcc) */

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <getopt.h>
#include <sys/ioctl.h>
#include <time.h>

time_t time();
time_t clck;  
time_t future;
struct tm *tm;

#define FALSE 0
#define TRUE  1

static int opt_m = FALSE;
static int opt_n = FALSE;
static int opt_s = FALSE;
static int opt_t = FALSE;

static void usage (void)
{
  puts ("Usage: loop [-t] [-n<count>] [-m] [-s<count>] [<prog>] [..<progx>]");
  puts ("");
  puts ("    -t will report time used.");
  puts ("    -n loop count.");
  puts ("    -s sleep for count");
  puts ("    -m sleep count is in miliseconds : default is seconds");	
  puts ("");
  
  exit (1);
}

int main (int argc, char *argv[])
{
  int i, err, c, x, m, n, ncount, scount;
  int days, hours, minutes, seconds;
  time_t starttime,nowtime, delta;

  opterr = FALSE; optswchar = "-"; optind = 0;
  while ((c = getopt (argc, argv, "tmn:s:")) != EOF)
    {
      switch (c)
        {
        case 't':
          opt_t = TRUE;
          break;
        case 'm':
          opt_m = TRUE;
          break;
        case 'n':
          ncount = atoi (optarg);
          if (ncount < 1 )
            usage ();
          opt_n = TRUE;
          break;
        case 's':
          scount = atoi (optarg);
          if (scount < 1 )
            usage ();
          opt_s = TRUE;
          break;
        default:
          usage ();
        }
    }

  if (optind == argc)
              usage ();
              
    starttime = time(NULL);
    
    while(ncount--)
    {
    	for (i = optind; i<argc ; i++)
    	{
    		if ( (err = system(argv[i])) != 0)
    		exit(err);
	}
	if (opt_t == TRUE)
	{
		nowtime = time(NULL);
	        delta = nowtime-starttime;
	        days = (int)(delta/86400L);
	        delta -= (time_t)days * 86400L;
		hours = (int)(delta/3600L);
		delta -= (time_t)hours * 3600L;
		minutes = (int)(delta/60L);
		delta -= (time_t)minutes * 60L;
		seconds = delta;
		time (&clck);
		tm=localtime(&clck);
		fprintf(stdout," %02.02d/%02.02d/%02.02d %02.02d:%02.02d:%02.02d  up for:  %d days  %d hours  %d minutes %d seconds\n",  tm->tm_year, tm->tm_mon + 1, tm->tm_mday, tm->tm_hour,tm->tm_min, tm->tm_sec,days, hours, minutes, seconds);
	}

	if (opt_s == TRUE){
		if (opt_m == TRUE)
		{		
		if (opt_t == TRUE)
		fprintf(stdout,"Wait %d miliseconds\n",scount);
		_sleep2(scount);
		} else
		{
		if (opt_t == TRUE)
		fprintf(stdout,"Wait %d Seconds\n",scount);
		sleep(scount);
		}

	}
	if (opt_n == FALSE) ncount = 100;
    }

}

